 
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
/**
 * Tile Class for TileGrid, TileGridApplet 
 * @author Chris Thiel
 * @version 24 May 2010 3pm
 *
 */



public class Tile {

	protected int row;
	protected int col;
	protected TileGrid grid;
	protected Color color;
	protected BufferedImage img;
	protected double angle;
	
	
	public Tile(int row,int col){
		this.row=row;
		this.col=col;
		this.grid=null;
		this.color=Color.RED;
		img=null;
		angle=0.0;
	}
	public Tile(){
		this(-1, -1);
	}
	public BufferedImage getImg(){
		return img;
	}
	public void setImg(BufferedImage img){
		this.img=img;
	}
	public double getAngle(){
		return angle;
	}
	public void setAngle(double angle){
		this.angle=angle;
	}
	public void turnUp(){
		this.angle=0;
	}
	public void turnDown(){
		this.angle=Math.PI;
	}
	public void turnLeft(){
		this.angle=Math.PI/-2.0;
	}
	public void turnRight(){
		this.angle=Math.PI/2.0;
	}
	public Tile(int row, int col, Color color){
		this(row,col);
		this.color=color;
	}
	public Tile(Color color){
		this(-1,-1);
		this.color=color;
	}
	public Tile(BufferedImage img){
		this(-1,-1);
		this.img=img;
	}
	public int getRow() {
		return row;
	}
	public void setRow(int row){
		this.row=row;
	}
	public int getCol() {
		return col;
	}
	public void setCol(int col) {
		this.col= col;
	}
	public Color getColor(){
		return color;
	}
	public void setColor(Color color){
		this.color=color;
	}
	public void act(){
		
	}

	public void draw(Graphics g, int x, int y, int size) {
		if(img==null){
			g.setColor(color);
			g.fillOval(x+3, y+3, size-6, size-6);
		}else{
			Graphics2D g2=(Graphics2D)g;
			AffineTransform at=new AffineTransform();
			at.setToIdentity();
			double anchorx=(x+size/2.0);
			double anchory=(y+size/2.0);
			at.rotate(angle, anchorx, anchory);
			double xFactor=(double)size/img.getWidth();
			double yFactor=(double)size/img.getHeight();
			at.scale(xFactor, yFactor);
			at.translate(x/xFactor, y/yFactor);
			
			g2.drawImage(img, at,null);
			
		}
	}

	public void setGrid(TileGrid tileGrid) {
		this.grid=tileGrid;
		
	}
	public TileGrid getGrid(){
		return this.grid;
	}
	public void removeSelfFromGrid(){
		grid.remove(this);
		grid=null;
		
	}

}
